Hooks:PostHook(PlayerManager, "attempt_ability", "Nomad_attempt_ability", function(self, ability)
	if managers.blackmarket:equipped_grenade() == "nomad_luck" then
		if not self:player_unit() then
			return
		end
	
		local local_peer_id = managers.network:session():local_peer():id()
		local has_no_grenades = self:get_grenade_amount(local_peer_id) == 0
		local is_downed = false
		local swan_song_active = managers.player:has_activate_temporary_upgrade("temporary", "berserker_damage_multiplier")
	
		if has_no_grenades or is_downed or swan_song_active then
			return
		end
	
		local attempt_func = self["_attempt_" .. ability]
	
		if attempt_func and not attempt_func(self) then
			return
		end
	
		local tweak = tweak_data.blackmarket.projectiles[ability]
	
		self:add_grenade_amount(-1)
		self._message_system:notify("ability_activated", nil, ability)
	end
end)

function PlayerManager:_attempt_nomad_luck()
	if game_state_machine:verify_game_state(GameStateFilters.downed) then
		Nomadluck:Play("UseNomadluck")
		self:add_grenade_amount(-1)
		self:send_message(Message.RevivePlayer, nil, nil)
	end
	return false -- false Does not allow the attempt_ability() to remove 1 nade
end
	
if not ModCore then
	log("[ERROR] BeardLib is not installed!")
	return
else
	Nomadluck = Nomadluck or ModCore:new(ModPath .. "main.xml", true, true)
	
	tweak_data.blackmarket.projectiles.nomad_luck.sounds.activate = {
		cooldown = "perkdeck_cooldown_over"
	}
	
	local movie_ids = Idstring("movie")
	function Nomadluck:Play(sound)
		if not PackageManager:has(movie_ids, Idstring(sound)) then
			return
		end
		local p = managers.menu_component._main_panel
		local name = "Nomadluck"..sound
		if alive(p:child(name)) then
			managers.menu_component._main_panel:remove(p:child(name))
		end		
		local volume = managers.user:get_setting("sfx_volume")
		local percentage = (volume - tweak_data.menu.MIN_SFX_VOLUME) / (tweak_data.menu.MAX_SFX_VOLUME - tweak_data.menu.MIN_SFX_VOLUME)
		managers.menu_component._main_panel:video({
			name = name,
			video = sound,
			visible = false,
			loop = false,
		}):set_volume_gain(percentage)
	end

end

Hooks:PostHook(PlayerManager, "health_skill_multiplier", "Nomad_first_wave", function(self)
	local multiplier = 1
	multiplier = multiplier + self:upgrade_value("player", "first_wave_legacy", 1) - 1
	return multiplier
end)

Hooks:PostHook(PlayerManager, "damage_reduction_skill_multiplier", "Nomad_first_wave_reduction", function(self)
	local multiplier = 1
	multiplier = multiplier * self:upgrade_value("player", "first_wave_legacy_damage_reduction", 1)
	multiplier = multiplier * self:temporary_upgrade_value("temporary", "nomad_luck_resist", 1)
	
	return multiplier
end)

Hooks:PostHook(PlayerManager, "on_killshot", "Nomad_kill_to_heal", function(self)
	if self:has_category_upgrade("player", "nomad_kill_to_heal") then
		self:local_player():character_damage():change_health(
		self:local_player():character_damage():_max_health() * self:upgrade_value("player", "nomad_kill_to_heal", 0),						
		true
	)
	end

	if managers.blackmarket:equipped_grenade() == "nomad_luck" then
	local gain_throwable_per_kill = managers.player:upgrade_value("team", "crew_throwable_regen", 0)
	
		if gain_throwable_per_kill ~= 0 then
			self._throw_regen_kills = (self._throw_regen_kills or 0) + 1

			if gain_throwable_per_kill < self._throw_regen_kills then
				managers.player:add_grenade_amount(0, true)

				self._throw_regen_kills = 0
			end
		end
	end
end)

Hooks:PostHook(PlayerManager, "add_grenade_amount", "MadMilkPerkDeck_Used", function(self, amount)
	if managers.blackmarket:equipped_grenade() == "nomad_luck" and amount and amount < 0 then
		managers.player:activate_temporary_upgrade("temporary", "nomad_luck_resist")
	end
end)